function OnHourainingyou01AttackLanded(keys)
	local caster = EntIndexToHScript(keys.caster_entindex)
	local target = keys.target
	
	if RollPercentage(keys.chance) then
		local DamageTable = {
	   			ability = keys.ability,
	            victim = target, 
	            attacker = caster, 
	            damage = caster:THTD_GetAbilityPowerDamage(keys.ability), 
	            damage_type = keys.ability:GetAbilityDamageType(), 
	            damage_flags = DOTA_DAMAGE_FLAG_NONE
	   	}
	   	UnitDamageTarget(DamageTable)
		   
		if not target:HasModifier("modifier_hourainingyou_01_stun_lock") then 
			keys.ability:ApplyDataDrivenModifier(caster, target, "modifier_hourainingyou_01_stun_lock", {Duration = keys.lock_time})	
		   	UnitStunTarget(caster,target,keys.stun_time)		   
		end
	end
end